package ru.ispras.telecomtesk.eap.EAPTLS;

import java.util.ArrayList;

import ru.ispras.telecomtesk.eap.*;
import ru.ispras.telecomtesk.eap.EAPTTLSv0.EAPtypePldTtlsv0;
import ru.ispras.telecomtesk.eap.EAPoverRadius.EAPRadiusSocket;

public class EAPTlsFragmentation {    
	public byte flag = 0; 
	public int  tlsMessageLenght = 0;
	public byte[] tlsData = null; 
	protected boolean isLengthEnable = false;
	public boolean isLengthSet = false;
/*
	public static int getAllTlsFragments(EAPRadiusSocket sock, ArrayList<EAPtypePldTls> tlsMsgsList) {
		int res = 0;
		boolean cicleFlag = true;
		EAPheader recvEAP;
		EAPtypePldTtlsv0 curpld;

		if((sock == null) || (tlsMsgsList == null)) {
			DebugInfo.printMessage(1,"!!! Error! EAPTlsFragmentation::getAllTlsFragments null pointer");
			return 1;
		}

		EAPpldBasic ttlsEapFragACK = new EAPpldResponse(1,EAPtype.EAP_TYPE_TTLSv0);

		ttlsEapPktCH.EAPmethodPld = new EAPtypePldTtlsv0();
		tlsFullMsgLen = 0;

		while(cicleFlag) {
			res = sock.sendEAPpacket();
			if((res == 0) && (sock.receivedData)) {
				recvEAP = sock.getReceivedEAPPacket();
				cicleFlag = false;

				if(recvEAP instanceof EAPpldBasic) {
					if(((EAPpldBasic) recvEAP).type == EAPtype.EAP_TYPE_TTLSv0) {
						curpld = (EAPtypePldTtlsv0)((EAPpldBasic)recvEAP).EAPmethodPld;
						if(curpld.getEapTlsLBit()) {
							if(tlsFullMsgLen == 0)
								tlsFullMsgLen = curpld.tlsMessageLenght;
							else {
								DebugInfo.printMessage(1,"!!! Warning! tlsMessageLenght dublicate");
							}
						}
						tlsMsgsList.add(curpld.tlsData);
						if(curpld.getEapTlsMBit()) {
							cicleFlag = true;
							ttlsEapFragACK.identifier = sock.getReceivedEAPPacket().identifier;
							ttlsEapFragACK.toByteArray();
							sock.setEapMessage(ttlsEapFragACK);
						}
					}
				}
			} else {
				DebugInfo.printMessage(1,"!!! Warning! EAPTlsFragmentation::getAllTlsFragments cannot get next fragment");
				res = 2;
				cicleFlag = false;
			}
		}
		return res;
	}
*/
	public static byte[] combineTlsMessages(ArrayList<byte[]> tlsMsgsList) {
		byte[] ba = null;
		int i, len=0, pos=0;

		if(tlsMsgsList != null) {
			DebugInfo.printMessage(5,"EAPTlsFragmentation::combineTlsMessages ArrayList size: " + tlsMsgsList.size());
			for(i=0; i < tlsMsgsList.size(); i++) {
				if(tlsMsgsList.get(i) != null)
					len += tlsMsgsList.get(i).length;
			}
			DebugInfo.printMessage(3,"EAPTlsFragmentation::combineTlsMessages full tls length: " + len);
			if(len > 0) {
				ba = new byte[len];
		
				for(i=0; i < tlsMsgsList.size(); i++) {
					if(tlsMsgsList.get(i) != null) {
						System.arraycopy(tlsMsgsList.get(i), 0, ba, pos, tlsMsgsList.get(i).length);
						pos += tlsMsgsList.get(i).length;
					}
					len += tlsMsgsList.get(i).length;
				}
			}
		}

		return ba;
	}
}