package ru.ispras.telecomtesk.eap.EAPoverLAN;

public enum EAPOLtype { 
	EAPOL_TYPE_PACKET(0),
	EAPOL_TYPE_START(1),
	EAPOL_TYPE_LOGOFF(2),
	EAPOL_TYPE_KEY(3),
	EAPOL_TYPE_ASF_ALERT(4),
	EAPOL_TYPE_UNKNOWN(255);
	
	private byte type;
	
	private EAPOLtype(int type) {
		this.type = (byte)type;
	}
	
	private EAPOLtype(byte type) {
		this.type = type;
	}

	public byte getValue() {
		return type;
	}

	public static EAPOLtype valueOf(int tp) {
		switch (tp) {
		case 0:	return EAPOL_TYPE_PACKET;
		case 1: return EAPOL_TYPE_START;
		case 2:	return EAPOL_TYPE_LOGOFF;
		case 3:	return EAPOL_TYPE_KEY;
		case 4:	return EAPOL_TYPE_ASF_ALERT;
		default: return EAPOL_TYPE_UNKNOWN;
		}
	}

	public static String toString(int tp) {
		EAPOLtype tmpval = EAPOLtype.valueOf(tp);
		String value = "" + tmpval;
		if(tmpval == EAPOLtype.EAPOL_TYPE_UNKNOWN) {
			value += " " + tp;
		}
		return value;
	}
}