package ru.ispras.telecomtesk.eap.EAPSIM.Attributes;

import ru.ispras.telecomtesk.eap.EAPSIM.EAPsimAttribute3;
import ru.ispras.telecomtesk.eap.EAPSIM.EAPsimAttrType;


public class EAPsimAttrMAC extends EAPsimAttribute3 {

	public EAPsimAttrMAC() {
		super();
		this.attrType = EAPsimAttrType.EAPSIM_AT_MAC.getValue();
		if(attrData != null) {
                        for(int i=0; i<attrData.length; i++) {
				attrData[i] = 0;
                        }
                }
	}
	
	public EAPsimAttrMAC(byte[] userMAC) {
		super(userMAC);
		this.attrType = EAPsimAttrType.EAPSIM_AT_MAC.getValue();
	}
	
	// parse message constructor 
	public EAPsimAttrMAC(byte[] data, int len, int pos) {
		super(data, len, pos);
		this.attrType = EAPsimAttrType.EAPSIM_AT_MAC.getValue();
	}
	
}    
