package ru.ispras.telecomtesk.eap.EAPSIM;

public enum EAPSIMsubtype { 
	EAPSIM_SUBTYPE_UNKNOWN(0),
	EAPSIM_SUBTYPE_START(10),
	EAPSIM_SUBTYPE_CHALLENGE(11),
	EAPSIM_SUBTYPE_NOTIFICATION(12),
	EAPSIM_SUBTYPE_REAUTHENTICATION(13),
	EAPSIM_SUBTYPE_CLIENT_ERROR(14),
	EAPSIM_SUBTYPE_EXPERIMENTAL(255);
	
	public int type;
	
	private EAPSIMsubtype(int type) {
		this.type = type;
	}
	
	public int getValue() {
		return type;
	}

	public static EAPSIMsubtype valueOf(int tp) {
		switch (tp) {
		case 0:	return EAPSIM_SUBTYPE_UNKNOWN;
		case 10: return EAPSIM_SUBTYPE_START;
		case 11: return EAPSIM_SUBTYPE_CHALLENGE;
		case 12: return EAPSIM_SUBTYPE_NOTIFICATION;
		case 13: return EAPSIM_SUBTYPE_REAUTHENTICATION;
		case 14: return EAPSIM_SUBTYPE_CLIENT_ERROR;
		default: return EAPSIM_SUBTYPE_EXPERIMENTAL;
		}
	}
}