package ru.ispras.telecomtesk.eap;

public class TestIteratorComlex {
	TestIterator[] itr;
    boolean isEnd;
    
    public TestIteratorComlex(TestIterator[] itr) {
    	this.itr = itr;
    	this.isEnd = true;
    	if(itr != null) {
    		for(int i=0;i < itr.length; i++) {
    			if(itr[i] == null) return;
    			itr[i].clear();
    		}
			this.isEnd = false;
    	}
    }
    public boolean next() {
    	if(!this.isEnd) {
    		for(int i=0;i < itr.length; i++) {
    			if(itr[i].next()) return true;
    			itr[i].clear();
    		}
    		this.isEnd = true;
    	}
    	return (!this.isEnd);
    }
    public void end() {
    	this.isEnd = true;
    }
    public boolean isEnd() {
    	return this.isEnd;
    }
    public void clear() {
    	this.isEnd = false;
   		for(int i=0;i < this.itr.length; i++) {
   			this.itr[i].clear();
   		}
    }
}