package ru.ispras.telecomtesk.tlsv12.HandshakeMessages.KeyExchange;


public class ServerDHParams
{
	public byte[] dh_p;
	public byte[] dh_g;
	public byte[] dh_Ys;

	public ServerDHParams(byte[] dh_p, byte[] dh_g, byte[] dh_Ys) {
		this.dh_p = dh_p; this.dh_g = dh_g; this.dh_Ys = dh_Ys;
	}
	
	public boolean isDHempty() {
		if((dh_p == null) || (dh_g == null) || (dh_Ys == null)) return true;
		else return false;
	}
	public int getSize() {
		if((dh_p == null) || (dh_g == null) || (dh_Ys == null)) return 0;
		else return (6 + (short)dh_p.length + (short)dh_g.length + (short)dh_Ys.length);
	}
	public byte[] toByteArray() {
		int i = 0;
		byte[] res = new byte[getSize()];
		if(res.length != 0) {
			res[i++] = (byte)(dh_p.length >>> 8);
			res[i++] = (byte)dh_p.length;
			System.arraycopy(dh_p, 0, res, i, (short)dh_p.length);
			i += (short)dh_p.length;
			res[i++] = (byte)(dh_g.length >>> 8);
			res[i++] = (byte)dh_g.length;
			System.arraycopy(dh_g, 0, res, i, (short)dh_g.length);
			i += (short)dh_g.length;
			res[i++] = (byte)(dh_Ys.length >>> 8);
			res[i++] = (byte)dh_Ys.length;
			System.arraycopy(dh_Ys, 0, res, i, (short)dh_Ys.length);
			i += (short)dh_Ys.length;
		}
		return res;
	}
}

