package ru.ispras.telecomtesk.tlsv12.RecordProtocol;

import ru.ispras.telecomtesk.tlsv12.DebugInfo;

public class ApplicationData {
	public byte[] data;
	
	public ApplicationData() {data = new byte[0];}
	public ApplicationData(byte[] data) {this.data = data;}
	public byte[] toByteArray() {
		return data;
	}
	public String toString() {
		if(data != null) {
			DebugInfo.printDump(3, data, "ApplicationData::toString: raw:");
			String res = "ApplicationData length " + data.length;
			if(data.length > 0) {
				if(data.length < 100)
					res += "\n" + new String(data);
				else
					res += "\n Data is too big to print";
			}
			return res;
		}
		else
			return "ApplicationData null";
	}
}
