package ru.ispras.telecomtesk.tlsv12.TLSAlgorithms;

public enum HashAlgorithm {
	NONE(0),
	MD5(1),
	SHA1(2),
	SHA224(3),
	SHA256(4),
	SHA384(5),
	SHA512(6),
	UNKNOWN(255);
	
	public byte hashalg;
	
	private HashAlgorithm(int alg) {
		hashalg = (byte)alg;
	}
	public byte getValue(){
		return hashalg;
	}
	public static HashAlgorithm valueOf(byte alg) {
		switch (alg) {
		case 0: return NONE;
		case 1: return MD5;
		case 2: return SHA1;
		case 3: return SHA224;
		case 4: return SHA256;
		case 5: return SHA384;
		case 6: return SHA512;
		default: return UNKNOWN;
		}
	}
}

