package ru.ispras.telecomtesk.tlsv12.TLSAlgorithms;

public enum KeyExchangeAlgorithm {
	NULL,
	DHE_DSS,
	DHE_RSA,
	DH_ANON,
	RSA,
	DH_DSS,
	DH_RSA;
	
	public static boolean isDHalgorithm(KeyExchangeAlgorithm alg) {
		switch(alg) {
		case DHE_DSS:
		case DHE_RSA:
		case DH_ANON:
		case DH_DSS:
		case DH_RSA:
			return true;
		default:
			return false;
		}
	}

	public boolean equals(KeyExchangeAlgorithm alg) {
		return (this == alg);
	}
}
