package ru.ispras.telecomtesk.tlsv12.TLSState;

public enum TLSScenarioState
{
	DISCONNECTED(false,0),
	CONNECTED(true,0),
	AFTER_ServerHello(true,1),
	AFTER_ServerHelloResume(true,2),
	AFTER_ServerCertificate(true,3),
	AFTER_ServerKeyExchange(true,4),
	AFTER_CertificateRequest(true,5),
	AFTER_ServerHelloDone(true,6),
	AFTER_ServerChangeCipherSpec(true,7),
	AFTER_ServerFinished(true,8),
	AFTER_ClientHELLO(true,9),
	AFTER_ClientHELLOResume(true,10),
	AFTER_ClientCertificate(true,11),
	AFTER_ClientKeyExchange(true,12),
	AFTER_CertificateVerify(true,13),
	AFTER_ClientChangeCipherSpec(true,14),
	AFTER_ClientFinished(true,15),
	AFTER_ClientCloseNotify(true,16),
	AFTER_ServerCloseNotify(true,17);
	
	public boolean connected;
	public int messageType;

	private TLSScenarioState(boolean connected, int type){
		this.connected = connected;
		this.messageType = type;
	}

	public boolean isClosingSession(){
		if(  this != AFTER_ClientCloseNotify
		  && this != AFTER_ServerCloseNotify)
			return false;
		else
			return true;
	}
}
